using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class ColorCorrection : ImageEffect
{
	public float brightness = 0.0f;
	public float contrast = 1.0f;

	Material material1 = null;
	Shader shaderColorCorrection = null;

	RenderTexture sceneRt = null;

	RenderTexture outRt = null;

	void Start()
	{
		material1 = new Material("ColorCorrectionPS1");
		shaderColorCorrection = Shader.Load("Shaders/ImageEffects/ColorCorrection.shader");

		material1.shader = shaderColorCorrection;

		material1.SetParameter("brightness", brightness);
		material1.SetParameter("contrast", contrast);

		outRt = new RenderTexture(Screen.width, Screen.height, RenderTexture.TextureType.ColorOnly);
	}

	public override void UpdateRT(int width, int height)
	{
		if (outRt != null)
			outRt.Reset(width, height);
	}

	void OnRenderImage(RenderTexture scene, RenderTexture source)
	{
		if (sceneRt != source)
		{
			material1.SetParameter("image1", source.colorTexture);
			sceneRt = source;
		}

		Graphics.Blit(material1, outRt, true);
	}

	void OnDestroy()
	{
		if (outRt != null)
			outRt.Dispose();
	}
}
